// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'PrintSM.pas' rev: 3.00

#ifndef PrintSMHPP
#define PrintSMHPP
#include <Db.hpp>
#include <SMRPars.hpp>
#include <SMRCnst.hpp>
#include <SMRExprt.hpp>
#include <SMRPESet.hpp>
#include <SMRTypes.hpp>
#include <SMPrntr.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Printsm
{
//-- type declarations -------------------------------------------------------
enum TSMRLangID { lnEnglish, lnRussian, lnUkrainian, lnGerman, lnFrench, lnSpanish };

class DELPHICLASS TSMRLanguage;
class PASCALIMPLEMENTATION TSMRLanguage : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FAutoDetect;
	TSMRLangID FLanguageID;
	bool FAutoDetected;
	TSMRLangID FLangIDByAutoDetect;
	void __fastcall AutoDetectLangID(void);
	
public:
	__fastcall TSMRLanguage(void);
	TSMRLangID __fastcall GetLangID(void);
	
__published:
	__property bool AutoDetect = {read=FAutoDetect, write=FAutoDetect, nodefault};
	__property TSMRLangID LanguageID = {read=FLanguageID, write=FLanguageID, nodefault};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TSMRLanguage(void) { }
	
};

class DELPHICLASS TPageInfo;
class PASCALIMPLEMENTATION TPageInfo : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	int FPageWidth;
	int FPageHeight;
	void __fastcall SetPageWidth(int Value);
	void __fastcall SetPageHeight(int Value);
	
public:
	int intNumPage;
	int intNumBar;
	int OffsetLeft;
	int OffsetRight;
	int OffsetTop;
	int OffsetBottom;
	Graphics::TMetafile* Data;
	__property int PageWidth = {read=FPageWidth, write=SetPageWidth, nodefault};
	__property int PageHeight = {read=FPageHeight, write=SetPageHeight, nodefault};
public:
	/* TObject.Create */ __fastcall TPageInfo(void) : System::TObject() { }
	/* TObject.Destroy */ __fastcall virtual ~TPageInfo(void) { }
	
};

enum TStatus { stIdle, stPrinting, stPrinted };

typedef void __fastcall (__closure *TPageEvent)(System::TObject* Sender, int Page, int Bar);

enum PrintSM__3 { ftTop, ftBottom, ftLeft, ftRight };

typedef Set<PrintSM__3, ftTop, ftRight>  TSMFrameType;

enum TSMPicType { btNone, btCenter, btStretch, btTile, btTileAsFrame, btCorners };

class DELPHICLASS TSMRFrame;
class PASCALIMPLEMENTATION TSMRFrame : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FBottom;
	bool FLeft;
	bool FRight;
	bool FTop;
	Controls::TControl* FParent;
	TPenStyle FPenStyle;
	int FWidth;
	Graphics::TColor FColor;
	Graphics::TColor FBackColor;
	Graphics::TPicture* FPicture;
	TSMPicType FPicType;
	void __fastcall SetColor(int Index, Graphics::TColor Value);
	void __fastcall SetParent(Controls::TControl* Value);
	void __fastcall SetStyle(Graphics::TPenStyle Value);
	void __fastcall SetValue(int Index, bool Value);
	void __fastcall SetWidth(int Value);
	TSMFrameType __fastcall GetFrameType(void);
	void __fastcall SetFrameType(TSMFrameType Value);
	void __fastcall SetPicture(Graphics::TPicture* Value);
	
protected:
	void __fastcall SetPen(Graphics::TPen* Value);
	
public:
	__fastcall TSMRFrame(void);
	__fastcall virtual ~TSMRFrame(void);
	bool __fastcall AnyFrame(void);
	int __fastcall GetFrameWidth(void);
	void __fastcall DrawFrame(Graphics::TCanvas* ACanvas, const Windows::TRect &ARect);
	__property Controls::TControl* Parent = {read=FParent, write=SetParent};
	__property bool DrawTop = {read=FTop, write=SetValue, index=0, nodefault};
	__property bool DrawBottom = {read=FBottom, write=SetValue, index=1, nodefault};
	__property bool DrawLeft = {read=FLeft, write=SetValue, index=2, nodefault};
	__property bool DrawRight = {read=FRight, write=SetValue, index=3, nodefault};
	
__published:
	__property Graphics::TColor Color = {read=FColor, write=SetColor, index=0, nodefault};
	__property Graphics::TPenStyle Style = {read=FPenStyle, write=SetStyle, default=0};
	__property int Width = {read=FWidth, write=SetWidth, default=1};
	__property TSMFrameType FrameType = {read=GetFrameType, write=SetFrameType, nodefault};
	__property Graphics::TColor BackColor = {read=FBackColor, write=SetColor, index=1, nodefault};
	__property Graphics::TPicture* Picture = {read=FPicture, write=SetPicture};
	__property TSMPicType PicType = {read=FPicType, write=FPicType, nodefault};
};

class DELPHICLASS TSMProperty;
class PASCALIMPLEMENTATION TSMProperty : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	System::AnsiString FAuthor;
	System::AnsiString FTitle;
	System::AnsiString FSubject;
	System::AnsiString FKeywords;
	Classes::TStrings* FComments;
	void __fastcall SetComments(Classes::TStrings* Value);
	
public:
	__fastcall TSMProperty(void);
	__fastcall virtual ~TSMProperty(void);
	
__published:
	__property System::AnsiString Author = {read=FAuthor, write=FAuthor};
	__property System::AnsiString Title = {read=FTitle, write=FTitle};
	__property System::AnsiString Subject = {read=FSubject, write=FSubject};
	__property System::AnsiString Keywords = {read=FKeywords, write=FKeywords};
	__property Classes::TStrings* Comments = {read=FComments, write=SetComments};
};

class DELPHICLASS TSMPrintBaseComponent;
class PASCALIMPLEMENTATION TSMPrintBaseComponent : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Classes::TNotifyEvent FBeginDoc;
	Classes::TNotifyEvent FEndDoc;
	TPageEvent FBeginPage;
	TPageEvent FEndPage;
	bool FPrepared;
	TStatus FStatus;
	Classes::TList* FPages;
	TSMProperty* FSMProperty;
	TSMRFrame* FFrame;
	bool FAnimatedStatus;
	TSMRLanguage* FLanguage;
	Smprntr::TSMRPrinter* FPrinterSetting;
	Smprntr::TSMRPrinter* FOldPrinterSetting;
	Classes::TNotifyEvent FOnBeforePreview;
	Classes::TNotifyEvent FOnPreview;
	Classes::TNotifyEvent FOnAfterPreview;
	Classes::TNotifyEvent FOnBeforePrint;
	Classes::TNotifyEvent FOnAfterPrint;
	bool FTwoPass;
	Smrtypes::TSMRVariables* FVariables;
	Smrpars::TGetVariableEvent FOnGetVariable;
	Smrtypes::TSMRVariables* __fastcall GetVariables(void);
	void __fastcall SetVariables(Smrtypes::TSMRVariables* Value);
	void __fastcall SetLanguage(TSMRLanguage* Value);
	void __fastcall SetPrinterSettings(Smprntr::TSMRPrinter* Value);
	void __fastcall SetFrame(TSMRFrame* Value);
	void __fastcall SavePrinter(void);
	void __fastcall RestorePrinter(void);
	TPageInfo* __fastcall GetPage(int intPg, int intBr);
	void __fastcall DrawLogo(void);
	void __fastcall SetSMProperty(TSMProperty* Value);
	
protected:
	int intMaxPageHeight;
	int intLastPageHeight;
	int intCurHeight;
	int intCurPassNumber;
	int intNumPages;
	int intNumBars;
	int __fastcall GetNumPages(void);
	int __fastcall GetNumBars(void);
	void __fastcall FreePages(void);
	void __fastcall PrintStart(void);
	void __fastcall PrintEnd(void);
	void __fastcall PrepareStart(void);
	void __fastcall PrepareEnd(void);
	virtual void __fastcall PrepareReport(void);
	void __fastcall InternalPreview(bool WithPrepare);
	System::Variant __fastcall GetSysDataValue(Smrcnst::TSMRSysDataType sdType);
	virtual int __fastcall GetPageNoCountBy(void);
	virtual int __fastcall GetPageNoStartAt(void);
	virtual int __fastcall GetCurColumn(void);
	virtual int __fastcall GetColumnNumber(void);
	void __fastcall SMRGetVariable(System::TObject* Sender, System::AnsiString VariableName, bool &Accept
		, Db::TFieldType &VariableType, System::Variant &Value);
	__property bool TwoPass = {read=FTwoPass, write=FTwoPass, nodefault};
	
public:
	System::AnsiString ProductVersion;
	int intCurPage;
	int intCurBar;
	Graphics::TMetafileCanvas* MFCanvas;
	__fastcall virtual TSMPrintBaseComponent(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMPrintBaseComponent(void);
	TPageInfo* __fastcall CurrentPage(void);
	virtual void __fastcall BeginDoc(void);
	virtual void __fastcall EndDoc(void);
	virtual void __fastcall NewPage(bool isNewBar);
	void __fastcall Prepare(void);
	void __fastcall Print(void);
	void __fastcall Preview(void);
	void __fastcall PreviewPreparedReport(void);
	void __fastcall LoadPreparedReport(const System::AnsiString FileName);
	void __fastcall SavePreparedReport(const System::AnsiString FileName);
	void __fastcall SavePageToFile(void);
	void __fastcall ExportTo(System::AnsiString FName, bool IsSeparatePages, Classes::TStrings* lstValidPages
		, System::TMetaClass* smreFilter);
	void __fastcall About(void);
	int __fastcall GetLanguageShift(void);
	System::AnsiString __fastcall F0D0(void);
	__property TPageInfo* Pages[int intPg][int intBr] = {read=GetPage};
	__property int NumPages = {read=GetNumPages, nodefault};
	__property int NumBars = {read=GetNumBars, nodefault};
	__property bool AnimatedStatus = {read=FAnimatedStatus, write=FAnimatedStatus, nodefault};
	__property TSMRFrame* Frame = {read=FFrame, write=SetFrame};
	__property Smprntr::TSMRPrinter* PrinterSetting = {read=FPrinterSetting, write=SetPrinterSettings};
		
	__property Smrtypes::TSMRVariables* Variables = {read=GetVariables, write=SetVariables};
	__property Smrpars::TGetVariableEvent OnGetVariable = {read=FOnGetVariable, write=FOnGetVariable};
	
__published:
	__property TSMRLanguage* Language = {read=FLanguage, write=SetLanguage};
	__property TSMProperty* SMProperty = {read=FSMProperty, write=SetSMProperty};
	__property Classes::TNotifyEvent OnBeginDoc = {read=FBeginDoc, write=FBeginDoc};
	__property Classes::TNotifyEvent OnEndDoc = {read=FEndDoc, write=FEndDoc};
	__property TPageEvent OnBeginPage = {read=FBeginPage, write=FBeginPage};
	__property TPageEvent OnEndPage = {read=FEndPage, write=FEndPage};
	__property Classes::TNotifyEvent OnPreview = {read=FOnPreview, write=FOnPreview};
	__property Classes::TNotifyEvent OnBeforePreview = {read=FOnBeforePreview, write=FOnBeforePreview};
		
	__property Classes::TNotifyEvent OnAfterPreview = {read=FOnAfterPreview, write=FOnAfterPreview};
	__property Classes::TNotifyEvent OnBeforePrint = {read=FOnBeforePrint, write=FOnBeforePrint};
	__property Classes::TNotifyEvent OnAfterPrint = {read=FOnAfterPrint, write=FOnAfterPrint};
};

class DELPHICLASS TSMPrintComponent;
class PASCALIMPLEMENTATION TSMPrintComponent : public Printsm::TSMPrintBaseComponent 
{
	typedef Printsm::TSMPrintBaseComponent inherited;
	
private:
	Graphics::TFont* FFont;
	void __fastcall SetFont(Graphics::TFont* Value);
	
public:
	__fastcall virtual TSMPrintComponent(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMPrintComponent(void);
	__property Graphics::TFont* Font = {read=FFont, write=SetFont};
	
__published:
	__property TwoPass ;
};

class DELPHICLASS TSMRCompositeReport;
class PASCALIMPLEMENTATION TSMRCompositeReport : public Printsm::TSMPrintBaseComponent 
{
	typedef Printsm::TSMPrintBaseComponent inherited;
	
private:
	Classes::TList* FReports;
	
public:
	__fastcall virtual TSMRCompositeReport(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMRCompositeReport(void);
	virtual void __fastcall PrepareReport(void);
	int __fastcall AddReport(TSMPrintBaseComponent* SMRep);
	void __fastcall RemoveReport(int i);
	void __fastcall ClearReports(void);
	__property Classes::TList* Reports = {read=FReports, write=FReports};
};

//-- var, const, procedure ---------------------------------------------------

}	/* namespace Printsm */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Printsm;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// PrintSM
